#<profile4xi profile = "02" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "lock4xi.py">
#<abstract4xi abstract = "provides Lock4Xi class"/>
#<refer4xi reference = "synchronize.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Lock4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass          
except:
    pass 
try:                 # imported-as ones 
    from time import time as _time, sleep as _sleep          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.synchronize import Lock  
except:
    print("lock4xi.py: *** failed in from multiprocessing.synchronize import Lock  ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi

from constant_synchronize4xi import ConstantSynchronize4Xi
from current_process4xi import get_name_current_process4xi
from current_process4xi import get_current_process4xi
from current_process4xi import get_inheriting_current_process4xi
from current_process4xi import get_authkey_current_process4xi    
from current_process4xi import get_identity_current_process4xi
from current_process4xi import get_counter_current_process4xi
from current_process4xi import get_daemonic_current_process4xi
from current_process4xi import get_tempdir_current_process4xi
from current_process4xi import get_children_current_process4xi
from current_process4xi import get_manager_server_current_process4xi

from examine4xi import examine4xi

from print4xi import print4xi

from reason_object4xi import reason_object4xi

from sense_object4xi import sense_object4xi
from semlock4xi import SemLock4Xi

from time4xi import time4xi
 
#"
#/>


        
# =======================================================================================================
#<class4xi class = "Lock4Xi" base = "SemLock4Xi" child = "None" synopsis = "Non-recursive lock" usage = "
#
#   condition4xi.py:
#       self._cond = Condition4Xi(Lock4Xi())
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =======================================================================================================
#
class Lock4Xi(SemLock4Xi):
    '''
    Non-recursive lock
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>
    # ---------------------------------------------------------------------------------------------
    # class  variables
    # ---------------------------------------------------------------------------------------------  
    #<define4xi definition = "
    _cs2xi = ConstantSynchronize4Xi()
    #"
    #/>                                     
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Lock4Xi" usage = "intializes Lock4Xi">                           
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self): 
        '''
        intializes Lock4Xi  
        ''' 

        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------          
       
        class2print = "Lock4Xi"
        method2print = "__init__"
        
        message2print = "{started" + "; init-of-Lock4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 01:21:04 04/08/13 Pacific Daylight Time
        
        message2print = "{borning" + "; lock2xi-of-Lock4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 01:21:04 04/08/13 Pacific Daylight Time
        
        message2print = "{inheriting" + "; SemLock4Xi-inheriting-by-lock2xi-of-Lock4Xi: " + str(SemLock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'semlock4xi.SemLock4Xi'>        
                        
        if examine4xi(class2print, method2print):  
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal
            # -------------------------------------------------------------------------------------             
            message2print = "{(StepOriginal) passing" + "; lock2xi-passing-to-Lock-init-by-init-of-Lock4Xi: " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 01:21:04 04/08/13 Pacific Daylight Time    
                             
            Lock.__init__(self)
            
            message2print = "{(StepOriginal) performed" + "; Lock-init-performed-by-init-of-Lock4Xi: " + str(Lock.__init__) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)              
            # <function Lock.__init__ at 0x00000000035632F0>; time: 01:43:28 04/08/13 Pacific Daylight Time} <-- JATKA - comes here but only if exception allowed to sellock4xi.py!            
        else:    
        
            # -----------------------------------------------------------------------------------------    
            # Step 1/3
            # -----------------------------------------------------------------------------------------          
            message2print = "{(Step 1/3a) shared" + "; cs2xi-shared-by-lock2xi-of-Lock4Xi: " + str(Lock4Xi._cs2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
            # <constant_synchronize4xi.ConstantSynchronize4Xi object at 0x0000000003583AC8>                              
       
                        
            semaphore2xi = Lock4Xi._cs2xi.get_semaphore()                             
 
            message2print = "{(Step 1/3b) set" + "; semaphore2xi-set-by-init-of-Lock4Xi to: " + str(semaphore2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # 1
            
            value2xi = Lock4Xi._cs2xi.get_sem_value()                                 
              
            message2print = "{(Step 1/3c) set" + "; value2xi-set-by-init-of-Lock4Xi to: " + str(value2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            
            maxvalue2xi = Lock4Xi._cs2xi.get_sem_value_max()                          
            
            message2print = "{(Step 1/3d) set" + "; maxvalue2xi-set-by-init-of-Lock4Xi to: " + str(maxvalue2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
            # 2147483647
            
            
            # -----------------------------------------------------------------------------------------    
            # Step 2/3
            # -----------------------------------------------------------------------------------------          
            message2print = "{(Step 2/3a) passing" + "; semaphore2xi-passing-to-SemLock4Xi-init-by-init-of-Lock4Xi: " + str(semaphore2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 1
            
            message2print = "{(Step 2/3b) passing" + "; value2xi-passing-to-SemLock4Xi-init-by-init-of-Lock4Xi: " + str(value2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 1
            
            message2print = "{(Step 2/3c) passing" + "; maxvalue2xi-passing-to-SemLock4Xi-init-by-init-of-Lock4Xi: " + str(maxvalue2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                               
            # 2147483647
            try:
             
                                                                             # note: the __init__ method of this class does NOT take any parameters
                                                                             # this is the highest level passing arguments to base class __init__ methods
                SemLock4Xi.__init__(self, semaphore2xi, value2xi, maxvalue2xi)   # dragonized SemLock.__init__(self, SEMAPHORE, 1, 1) <--- class Lock(SemLock) in synchronize.py            
            
                 
                message2print = "{(Step 2/3e) performed" + "; SemLock4Xi-init-performed-by-init-by-init-of-Lock4Xi: " + str(SemLock4Xi.__init__) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
            except:
                message2print = "{(Step 2/3f) yielded" + "; SemLock4Xi-init-yielded-by-init-of-Lock4Xi: " + str(SemLock4Xi.__init__)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                #PX: <function __init__ at 0x02D8FD20>
                
            # -----------------------------------------------------------------------------------------    
            # Step 3/3
            # -----------------------------------------------------------------------------------------           
            message2print = "{(Step 3/3b) activated" + "; lock2xi-of-Lock4Xi-activated: " + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)
            #PX: 
        
            message2print = "{(Step 3/3c) inherited" + "; SemLock4Xi-inherited-by-lock2xi-of-Lock4Xi: " + str(SemLock4Xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
        
            message2print = "{(Step 3/3d) returning" + "; init-of-Lock4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                                
                        
                                  
    #</methodize4xi>
                         
                            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-Lock4Xi" usage = "returns lock owner name">                         
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __repr__(self):
        '''
        returns lock owner name
        '''
        class2print = "Lock4Xi"
        method2print = "__repr__"
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        # message2print = "{(Step 1/7) stepping" + "; (Step 1/7)-stepping-by-repr-of-Lock4Xi: " + "~ starting to solve lock owner name ~"  + "; time: " + time4xi() + "}"
        # print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
        
        message2print = "{(Step 1/7a) started" + "; repr-of-Lock4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 07:15:09 03/24/13 Pacific Daylight Time

        if examine4xi(class2print, method2print):
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal
            # -------------------------------------------------------------------------------------             
            message2print = "{(StepOriginal) passing" + "; lock2xi-passing-to-Lock-repr-by-repr-of-Lock4Xi: " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
                
            message2print = "{(StepOriginal) returning" + "; Lock-repr-returning-by-repr-of-Lock4Xi: " + str(Lock.__repr__) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
                                                    
            return Lock.__repr__(self)
        else:

            # JATKA
            try:
                if self._semlock._is_mine():
                    
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                    # message2print = "{(Step 2/7) stepping" + "; (Step 2/7)-stepping-by-repr-of-Lock4Xi: " + "~ getting the name of the current process ~"  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)
                    # -------------------------------------------------------------------------------------------------------------------------------------------        
                   
                    name2xi = get_name_current_process4xi()

                    message2print = "{(Step 2/7a) set" + "; name2xi-set-by-repr-of-Lock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    

                    if threading.current_thread().name != 'MainThread':
                        name2xi += '|' + threading.current_thread().name
                        
                        message2print = "{(Step 2/7b) set" + "; name2xi-set-by-repr-of-Lock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)    
                             
                elif self._semlock._get_value() == 1:
                    
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                    # message2print = "{(Step 3/7a) stepping" + "; (Step 3/7)-stepping-by-repr-of-Lock4Xi: " + "~ handling semlock value 1 ~"  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)
                    # -------------------------------------------------------------------------------------------------------------------------------------------        
                      
                    name2xi = 'None'
                    
                    message2print = "{(Step 3/7b) set" + "; name2xi-set-by-repr-of-Lock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    
                    
                     
                elif self._semlock._count() > 0:
                    
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                    # message2print = "{(Step 4/7a) stepping" + "; (Step 4/7a)-stepping-by-repr-of-Lock4Xi: " + "~ some other thread ~"  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)
                    # -------------------------------------------------------------------------------------------------------------------------------------------        
                      
                    name2xi = 'SomeOtherThread'
                    
                    message2print = "{(Step 4/7b) set" + "; name2xi-set-by-repr-of-Lock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    
                else:
                    
                    # -------------------------------------------------------------------------------------------------------------------------------------------
                    # message2print = "{(Step 5/7a) stepping" + "; (Step 5/7a)-stepping-by-repr-of-Lock4Xi: " + "~ some other process  ~"  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)
                    # -------------------------------------------------------------------------------------------------------------------------------------------        
                      
                    name2xi = 'SomeOtherProcess'
                    
                    message2print = "{(Step 5/7b) set" + "; name2xi-set-by-repr-of-Lock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    
            except Exception:
                    
                # -------------------------------------------------------------------------------------------------------------------------------------------
                # message2print = "{(Step 6/7a) stepping" + "; (Step 6/7a)-stepping-by-repr-of-Lock4Xi: " + "~ *** unknown i.e. not a thread or process *** ~"  + "; time: " + time4xi() + "}"
                # print4xi(class2print, method2print, message2print)
                # -------------------------------------------------------------------------------------------------------------------------------------------        
                  
                name2xi = 'unknown'
                
                message2print = "{(Step 6/7b) set" + "; name2xi-set-by-repr-of-Lock4Xi to: " + str(name2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
            
            message2print = "{(Step 7/7) returning" + "; lock-owner-returning-by-repr-of-Lock4Xi: " + str(name2xi) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    

                            
            return '<Lock(owner=%s)>' % name2xi     
    #</methodize4xi>
            
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Lock4Xi" usage = "senses Lock4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses Lock4Xi class objects
        '''

        
        class2print = 'Lock4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-Lock4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; Lock4Xi-sensing-by-sense-of-Lock4Xi: " + str(Lock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                   
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Lock4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['mine-of-lock2xi'] = self._semlock._is_mine()
            kb2xi['semlock-of-lock2xi'] = self._semlock._get_value()
            kb2xi['count-of-lock2xi'] = self._semlock._count()        
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-Lock4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                
      
        message2print = "{sensed" + "; Lock4Xi-sensed-by-sense-of-Lock4Xi: " + str(Lock4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Lock4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Lock4Xi" usage = "reasons Lock4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons Lock4Xi class objects
        '''
       
        
        class2print = 'Lock4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-Lock4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Lock4Xi-reasoning-by-reason-of-Lock4Xi: " + str(Lock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-Lock4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['name-of-current-process'] = get_name_current_process4xi() 
        except:
            message2print = "{yielded" + "; kb4xi-yielded-by-reason-of-Lock4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 

        message2print = "{reasoned" + "; Lock4Xi-reasoned-by-reason-of-Lock4Xi: " + str(Lock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Lock4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Lock4Xi" usage = "aces class Lock4Xi objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces class Lock4Xi objects 
        '''
    
        
        
        class2print = 'Lock4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-Lock4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Lock4Xi-acing-by-ace-of-Lock4Xi: " + str(Lock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                  
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Lock4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------              
        try:
            kb8xi['current-process'] = get_current_process4xi()
            kb8xi['name-of-current-process'] = get_name_current_process4xi()
            kb8xi['inheritance-of-current-process'] = get_inheriting_current_process4xi()
            kb8xi['authkey-of-current-process'] = get_authkey_current_process4xi()    
            kb8xi['identity-of-current-process'] = get_identity_current_process4xi()
            kb8xi['counter-of-current-process'] = get_counter_current_process4xi()
            kb8xi['daemonic-of-current-process'] = get_daemonic_current_process4xi()
            kb8xi['tempdir-of-current-process'] = get_tempdir_current_process4xi()
            kb8xi['children-of-current-process'] = get_children_current_process4xi()
            kb8xi['manager-server-of-current-process'] = get_manager_server_current_process4xi()
        except:
            message2print = "{yielded" + "; kb8xi-yielded-by-ace-of-Lock4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
                        
        message2print = "{aced" + "; Lock4Xi-aced-by-ace-of-Lock4Xi: " + str(Lock4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Lock4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                           
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of lock4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

